﻿Imports System
Imports System.IO
Public Class MainForm
    'Deklarationen global
    '--------------------
    Dim Frequency As Double 'aktuelle Frequenz
    Dim Fmem As Double 'Merker
    Dim EIN As Boolean 'Status für Relais
    Dim AUS As Boolean
    Dim MODE As Boolean 'Betriebsart
    Dim SMode As Integer '0 = miniVNA, 1 = TRX
    Dim AUT As Boolean 'Betriebsart
    Dim MAN As Boolean 'Betriebsart
    Dim Uv As Single 'Spannung Vorlauf Richtkoppler
    Dim Ur As Single 'Spannung Rücklauf Richtkoppler
    Dim P As Single 'Sendeleistung
    Dim SWR As Single 'SWR
    Dim SWRrp As Single 'im Resonanzpunkt
    Dim SWRlimit As Single 'Abbruchschwelle beim Wiederanstieg
    Dim TBE As Integer 'Tabellenende Frequenzarray
    Dim Antenne As Integer 'Nr. der verwendeten Antenne
    Dim BandIndex As Integer 'Indes des aktuellen Bandes
    Dim BusyFlag As Boolean 'Flag für noch nicht abgeschlossene Aufgaben
    Dim TX As Boolean = False 'Flag für Sendebetrieb
    Dim Directory As String 'Verzeichnis für Daten
    Dim AFlag As Boolean 'Abbruch-Flag beim Tuning
    Dim StopFlag As Boolean 'TRX ist nicht verfügbar
    Dim FreqSWRmultiShot As Single 'Frequenz bei tiefstem SWR bei SWRmultiShot
    Dim TuningPower As Integer 'aktueller Wert
    Dim TuningPowerSaved As Integer 'gespeicherter Wert
    Dim StartFlag As Boolean = True
    'auf FALSE setzen, wenn Grundstellung von C1 und C2 nach Programmstart
    'erst durch Klicken auf DF9XS angefahren werden soll

    Dim x0 As Integer = 10 'für graphische Darstellung SWR
    Dim x1 As Integer
    Dim x2 As Integer
    Dim y0 As Integer = 10
    Dim y1 As Integer
    Dim y2 As Integer

    Dim PositionC(2) As Integer 'Array der mech. Positionen der Cs in Schritten
    Dim RPC(2) As Single 'Array der Resonanzpunkte C(1) und C(2)in %
    Dim SetpointC(2) As Integer 'Array der Sollwerte der Cs in Schritten
    Dim StepsC(2) As Integer 'Array der Zahl der Schritte für 100% Verstellung der Cs

    Dim StartButton As String = "ZZPS"
    Dim TunePowerSetting As String = "ZZTO"
    Dim OperatingMode As String = "ZZMD"
    Dim TuneStatus As String = "ZZTU"
    Dim FlexRadioStatus As String = "ZZIF"
    Dim SetVfoAFrequency As String = "ZZFA"

    Dim B(10, 8) As Object 'Bandparameter
    '1. Index:
    '0 = 160 m
    '1 = 80 m
    '2 = 40 m
    '3 = 30 m
    '4 = 20 m
    '5 = 17 m
    '6 = 15 m
    '7 = 12 m
    '8 = 10 m
    '9 = 6 m

    '2. Index:
    '0 = Bandname
    '1 = Frequenz Bandanfang
    '2 = Frequenz Bandende
    '3 = Schrittweite      
    '4 = Antenne
    '5 = SWRmax
    '6 = Wobbel-Bandbreite C1
    '7 = Wobbel-Bandbreite C2
    '8 = Faktor für Leistungsmessung

    Dim F(250, 2) As Double 'Frequenz-/Positionsdaten
    '1. Index: laufende Nr.
    '2. Index:
    '0 = Frequenz
    '1 = Sollwert C(1)
    '2 = Sollwert C(2)

    Dim PosBias(10, 2) As Integer 'Array der Korrekturwerte für Nachjustierung
    '1. Index: Bandindex
    '2. Index: 
    '1 = Korrekturwert für C(1)
    '2 = Korrekturwert für C(2)

    Dim R(10, 2) As Integer 'Indextabelle Bänder
    '1. Index: Bandindex
    '2. Index:
    '0 = Index Bandanfang
    '1 = Index Bandende

    Private Property DataGridView1 As Object
    '0 = Frequenz
    '1 = Position C1
    '2 = Position C2

    Public Sub adjustTuningPower()

        'Deklarationen
        '-------------
        Dim S As String = ""
        Dim I As Integer = 0

        'im TRX eingestellte Tuningleistung speichern
        '--------------------------------------------
        getTunePowerSetting()

        'Mindestleistung für Abstimmung ermitteln
        '----------------------------------------
        Me.SerialPort2.Write(StartButton & "1;") 'Power on
        Threading.Thread.Sleep(50)
        Me.SerialPort2.Write(OperatingMode & "07;") 'Betriebsart DIGU
        Threading.Thread.Sleep(50)
        Me.SerialPort2.Write(TunePowerSetting & "000;") 'Tuning Leistung 0 W
        Threading.Thread.Sleep(10)
        Me.SerialPort2.Write(TuneStatus & "1;") 'Tuning ein
        Me.TextBox2.BackColor = Color.Red()

        For I = 1 To 5 'max. 5 W für FLEX-3000
            Me.SerialPort2.Write(TunePowerSetting & Format(I, "000") & ";") 'Tuningleistung erhöhen
            My.Application.DoEvents()
            Threading.Thread.Sleep(50)
            getSWRantenna()
            If P >= 1 Then Exit For 'Leistung erreicht
        Next I

        Me.SerialPort2.Write(TuneStatus & "0;") 'Tuning aus
        TuningPower = I

        'Anzeige updaten
        '---------------
        Me.TextBox2.BackColor = Color.Black()

    End Sub
    Public Sub calculateIndexArray()

        'Indexarray berechnen, hält fest, welcher Index der Frequenztabelle jeweils Bandanfang und -Ende bestimmt
        '--------------------

        'Deklarationen
        '-------------
        Dim I As Integer
        Dim J As Integer = 0 'Laufvariable für Bandindex

        'Vergleich von Frequenz- und Banddaten
        '-------------------------------------
        For I = 0 To TBE
            If F(I, 0) = CDbl(B(J, 1)) Then R(J, 0) = I
            If F(I, 0) = CDbl(B(J, 2)) Then R(J, 1) = I : J = J + 1
        Next I
    End Sub
    Public Sub calculateSetpoints()

        'Deklarationen
        '-------------
        Dim I As Integer
        Dim FT, FH, PT, PH, FD, DF, FACTOR, PD, DP, PO As Single

        'zugeordnete Tabellenindizés suchen
        '----------------------------------
        For I = 0 To TBE
            If F(I, 0) > Frequency Then   '3,605
                I = I - 1
                Exit For
            End If
        Next I

        If I >= TBE Then I = TBE - 1 'Fehlervermeidung bei höchster Frequenz
        If I < 0 Then I = 0 'dto. bei < untere Bandgrenze

        FT = F(I, 0)                    'nächsttiefere Frequenz   3,60
        FH = F((I + 1), 0)              'nächtshöhere             3,61

        'Position C1
        '-----------
        PT = F(I, 1)                    'nächtsttiefere Position  60
        PH = F((I + 1), 1)              'nächtshöhere             58

        FD = FH - FT                    'Differenz zwischen den gespeicherten Frequenzmarken    0,01
        DF = Frequency - FT              'Differenz zwischen der tieferen Marke und dem Istwert  0,005

        FACTOR = DF / FD                'auf 1 normierter Anteil                                0,5

        PD = PH - PT                    'Differenz zwischen den gespeicherten Positionsmarken   -2
        DP = PD * FACTOR                'Differenz zwischen der tieferen Marke und dem Istwert  -1

        PO = PT + DP                    'gesuchte Position                                      59
        If PO < 0 Then PO = 0 'Sicherheits-Begrenzung

        SetpointC(1) = Math.Round(PO * StepsC(1) / 100, 0)  'Anpassung an Schrittmotor          295

        'Position C2
        '-----------
        PT = F(I, 2)                    'nächtsttiefere Position  60
        PH = F((I + 1), 2)              'nächtshöhere             58

        FD = FH - FT                    'Differenz zwischen den gespeicherten Frequenzmarken    0,01
        DF = Frequency - FT              'Differenz zwischen der tieferen Marke und dem Istwert  0,005

        FACTOR = DF / FD                'auf 1 normierter Anteil                                0,5

        PD = PH - PT                    'Differenz zwischen den gespeicherten Positionsmarken   -2
        DP = PD * FACTOR                'Differenz zwischen der tieferen Marke und dem Istwert  -1

        PO = PT + DP                     'gesuchte Position                                      59
        If PO < 0 Then PO = 0 'Sicherheits-Begrenzung

        SetpointC(2) = Math.Round(PO * StepsC(2) / 100, 0)  'Anpassung an Schrittmotor                              295

    End Sub
    Public Sub determineBand()

        'Deklarationen
        '-------------
        Dim I As Integer  'Laufvariable

        'Zuweisungen
        '-----------
        BandIndex = 10 'falls nichts gefunden wird

        'zugeordnetes Band finden
        '------------------------
        For I = 0 To 9
            If Frequency >= CDbl(B(I, 1)) And Frequency <= CDbl(B(I, 2)) Then
                Antenne = CInt(B(I, 4))
                BandIndex = I
                Exit For
            End If
        Next I

        'LEDs aktualisieren
        '------------------
        setLED(BandIndex)

    End Sub
    Public Sub disableButtons()

        Button1.Enabled = False
        Button3.Enabled = False
        Button5.Enabled = False
        Button7.Enabled = False
        Button4.Enabled = False
        Button6.Enabled = False
        Button6.Enabled = False
        Button8.Enabled = False
        Button2.Enabled = False
        RadioButton1.Enabled = False
        RadioButton2.Enabled = False
        CheckBox1.Enabled = False
        CheckBox2.Enabled = False
        TrackBar1.Enabled = False
        TrackBar2.Enabled = False
        Beep()

    End Sub
    Public Sub drawSWR(ByVal x, ByVal Colour, ByVal Width)

        'x = aktueller Wobbelschritt

        'Deklarationen
        '-------------
        Dim u As Graphics = LogForm.CreateGraphics()
        Dim myPen As New Pen(Color.Blue, Width)

        'Zuweisungen
        '-----------
        myPen.Color = Colour

        x2 = x0 + x 'horizontale Position
        y2 = y0 + (-SWR * 400) + 600 'vertikale Position

        If x > 0 Then u.DrawLine(myPen, x1, y1, x2, y2)

        If (y1 Or y2) < 0 Then
            u.DrawLine(myPen, 0 + x0, 5, 250 + x0, 5)
        Else
            myPen.Color = Color.Gray
            u.DrawLine(myPen, x0, 5, x0 + 250, 5)
        End If

        x1 = x2 'Übernahme der alten Koordinaten
        y1 = y2

    End Sub
    Public Sub enableButtons()

        Button1.Enabled = True
        Button3.Enabled = True
        Button5.Enabled = True
        Button7.Enabled = True
        Button4.Enabled = True
        Button6.Enabled = True
        Button6.Enabled = True
        Button8.Enabled = True
        Button2.Enabled = True
        RadioButton1.Enabled = True
        RadioButton2.Enabled = True
        CheckBox1.Enabled = True
        CheckBox2.Enabled = True
        TrackBar1.Enabled = True
        TrackBar2.Enabled = True
        Beep()

    End Sub
    Public Sub getBandIndex()

        If FrequencyForm.RadioButton1.Checked = True Then BandIndex = 0
        If FrequencyForm.RadioButton2.Checked = True Then BandIndex = 1
        If FrequencyForm.RadioButton3.Checked = True Then BandIndex = 2
        If FrequencyForm.RadioButton4.Checked = True Then BandIndex = 3
        If FrequencyForm.RadioButton5.Checked = True Then BandIndex = 4
        If FrequencyForm.RadioButton6.Checked = True Then BandIndex = 5
        If FrequencyForm.RadioButton7.Checked = True Then BandIndex = 6
        If FrequencyForm.RadioButton8.Checked = True Then BandIndex = 7
        If FrequencyForm.RadioButton9.Checked = True Then BandIndex = 8
        If FrequencyForm.RadioButton10.Checked = True Then BandIndex = 9

    End Sub
    Public Sub getTunePowerSetting()

        'Deklarationen
        '-------------
        Dim Buffer As String
        Dim I As Integer

        'Zuweisungen
        '-----------
        Buffer = ""

        'Kommando senden
        '---------------
        Me.SerialPort2.WriteTimeout = 500
        Try
            Me.SerialPort2.Write(TunePowerSetting & ";")
        Catch ex As TimeoutException
            Beep()
            Me.TextBox1.Text = "TRX fehlt!"
            StopFlag = True
            Exit Sub
        End Try

        'Antwort empfangen
        '-----------------
        Do
            My.Application.DoEvents()
            I = Me.SerialPort2.ReadChar
            Buffer = Buffer + Chr(I)
        Loop Until I = 59

        TuningPowerSaved = Val(Microsoft.VisualBasic.Right(Buffer, 3))

    End Sub
    Public Sub getStatusTRX()

        'Deklarationen
        '-------------
        Dim Buffer As String
        Dim I As Integer
        Dim S As String

        'Zuweisungen
        '-----------
        Buffer = ""

        'Kommando senden
        '---------------
        Me.SerialPort2.WriteTimeout = 500
        Try
            Me.SerialPort2.Write(FlexRadioStatus & ";")
        Catch ex As TimeoutException
            Beep()
            Me.TextBox1.Text = "TRX fehlt!"
            StopFlag = True
            Exit Sub
        End Try

        'Antwort empfangen
        '-----------------
        Do
            My.Application.DoEvents()
            I = Me.SerialPort2.ReadChar
            Buffer = Buffer + Chr(I)
        Loop Until I = 59

        If Mid(Buffer, 31, 1) = "1" Then 'Statusflag für Sendebetrieb
            TX = True
            Me.TextBox2.BackColor = Color.Red()
        Else
            TX = False
            Me.TextBox2.BackColor = Color.Black
        End If

        S = Mid(Buffer, 5, 11) 'Frequenz als String

        Frequency = Val(S) / 1000000
        Me.TextBox1.Text = Format(Val(Mid(S, 1, 5)), "##") _
            & "," & Mid(S, 6, 3) & "." & Mid(S, 9, 3) & " MHz"

    End Sub
    Public Sub getSWRantenna()

        'Deklarationen
        '-------------
        Dim Buffer As String 'Puffer für Quittierungsinfo
        Dim Ux As Single 'Hilfsvariable für Richtkoppler
        Dim A As Integer 'Position des /
        Dim I As Integer 'ASC Zeichen Eingabepuffer
        Dim L As Integer 'Länge Eingabepuffer

        'Zuweisungen
        '-----------
        BusyFlag = True
        Buffer = ""

        'Kommando senden
        '---------------
        Me.SerialPort1.ReadTimeout = 500
        Me.SerialPort1.Write("SWR" & vbCr)

        'Antwort empfangen
        '-----------------
        Me.SerialPort1.DiscardInBuffer()
        Try
            Do
                My.Application.DoEvents()
                I = Me.SerialPort1.ReadChar
                Buffer = Buffer + Chr(I)
            Loop Until I = 13
        Catch ex As TimeoutException
            Beep()
            Me.TextBox4.Text = "Timeout"
            Me.SerialPort1.Close()
            Me.SerialPort1.Open()
            BusyFlag = False
            Exit Sub
        End Try

        'Ergebnis errechnen
        '------------------
        A = InStr(Buffer, "/")
        L = Len(Buffer)

        Ux = Val(Mid(Buffer, 4, (A - 4)))
        Uv = 0.0025 * Ux
        Ur = 0.0025 * (Mid(Buffer, (A + 1), (L - A - 1)))

        If (Uv - Ur) = 0 Then
            P = 0
            SWR = 1
        Else
            SWR = (Uv + Ur) / (Uv - Ur)
            P = (Uv ^ 2) * B(BandIndex, 8)
            If P < 0.1 Or SWR < 1 Then SWR = 1
        End If

        'darstellen
        '----------
        Me.TextBox2.Text = "P = " & Format(P, "0.0") & " W"
        'Me.TextBox4.Text = Format(Uv, "0.00") & "/" & Format(Ur, "0.00")
        Me.TextBox4.Text = "SWR = " & Format(SWR, "0.00")
        BusyFlag = False

    End Sub
    Public Sub getSWRmultiShot()

        'abfragen
        '--------
        SWR = SWRmultiShot(Frequency)

        'Ergebnis darstellen
        '-------------------
        LogForm.TextBox2.Text = "SWR = " & Format(SWR, "0.000")
        LogForm.TextBox3.Text = Format(Frequency, "##.000") & " MHz"

    End Sub
    Public Sub getSWRsingleShot()

        'abfragen
        '--------
        SWR = SWRsingleShot(Frequency)

        'Ergebnis darstellen
        '-------------------
        LogForm.TextBox2.Text = "SWR = " & Format(SWR, "0.000")
        LogForm.TextBox3.Text = Format(Frequency, "##.000") & " MHz"

    End Sub
    Public Sub Init()

        'Zuweisungen
        '-----------
        With Me.SerialPort1
            .PortName = "COM1"                      'Schnittstellenparameter zum Stepper Loop Tuner alt:5
            .BaudRate = 300
            .DataBits = 8
            .Parity = IO.Ports.Parity.None
            .StopBits = IO.Ports.StopBits.One
            .Handshake = IO.Ports.Handshake.None
        End With

        With Me.SerialPort2
            .PortName = "COM15"                      'Schnittstellenparameter zu DDUtil
            .BaudRate = 9600
            .DataBits = 8
            .Parity = IO.Ports.Parity.None
            .StopBits = IO.Ports.StopBits.One
            .Handshake = IO.Ports.Handshake.None
        End With

        With Me.SerialPort3
            .PortName = "COM7"                      'Schnittstellenparameter zum miniVNA
            .BaudRate = 115200
            .DataBits = 8
            .Parity = IO.Ports.Parity.None
            .StopBits = IO.Ports.StopBits.One
            .Handshake = IO.Ports.Handshake.None
        End With

        Directory = "d:\Daten\VB 2010 Express\Stepper Loop Tuner 2.1\"

        StepsC(1) = 6000                            'Zahl der Schritte für 100% Stellbereich
        StepsC(2) = 744

        Me.TrackBar1.Maximum = StepsC(1)
        Me.TrackBar1.LargeChange = 10
        Me.TrackBar1.SmallChange = 1
        Me.TrackBar2.Maximum = StepsC(2)
        Me.TrackBar2.LargeChange = 10
        Me.TrackBar2.SmallChange = 1

        AUS = False
        EIN = True
        AUT = True
        MAN = False
        StopFlag = False

        MODE = AUT
        setMode(MODE)

        'Initialisierung
        '---------------
        'Port zur Antenne öffnen
        '-----------------------

        Try
            Me.SerialPort1.WriteTimeout = 500
            Me.SerialPort1.Open()
        Catch ex As TimeoutException 'falls Fehler beim Öffnen auftreten
            Beep()
            Me.SerialPort1.Close()
            Beep()
            Me.TextBox1.Text = "Timeout"
            Threading.Thread.Sleep(2000)
            Me.TextBox1.Text = "Port1, Antenne!"
            Threading.Thread.Sleep(3000)
            Stop
        End Try

        'Port zu PowerSDR öffnen
        '-----------------------
        Try
            Me.SerialPort2.WriteTimeout = 500
            Me.SerialPort2.Open()
        Catch ex As TimeoutException
            Beep()
            Me.SerialPort2.Close()
            Threading.Thread.Sleep(2000)
            Me.TextBox1.Text = "Port2, DDUtil, PowerSDR!"
            Threading.Thread.Sleep(3000)
            Stop
        End Try

        loadBandParameter()
        loadFrequencyPositionParameter()
        calculateIndexArray()
        getStatusTRX()

        If StopFlag = True Then 'TRX fehlt
            Me.SerialPort1.Close()
            Me.SerialPort2.Close()
            Me.SerialPort3.Close()
            Exit Sub
        End If

        determineBand()

        'Warten auf manuellen Start
        '--------------------------
        Do
            My.Application.DoEvents()
            If StartFlag = True Then Exit Do
            Threading.Thread.Sleep(1000)
        Loop

        setK1(AUS)
        setK2(AUS)

        My.Application.DoEvents()
        setHomePositionC(1)
        My.Application.DoEvents()
        setHomePositionC(2)

        Me.Focus()

    End Sub
    Public Sub loadBandParameter()

        'Deklarationen
        '-------------
        Dim Line As String
        Dim I As Integer
        Dim J As Integer

        'Zuweisungen
        '-----------
        Line = ""

        'Daten von Platte ins Array laden
        '--------------------------------
        Using sr As StreamReader = New StreamReader(Directory + "Band.dat")

            For I = 0 To 9 'Zeilen
                For J = 0 To 8 'Spalten
                    Line = sr.ReadLine()
                    B(I, J) = Line
                Next J
            Next I
            sr.Close()

            'Daten vom Array in Tabelle laden
            '--------------------------------
            BandForm.DataGridView2.ColumnCount = 9
            BandForm.DataGridView2.RowCount = 10

            For I = 0 To 9
                For J = 0 To 8
                    BandForm.DataGridView2.Rows(I).Cells(J).Value = B(I, J)
                Next J
            Next I

        End Using

    End Sub
    Public Sub loadFrequencyPositionParameter()

        'Deklarationen
        '-------------
        Dim Line As String
        Dim I As Integer

        'Zuweisungen
        '-----------
        Line = ""

        'Daten von Platte ins Array laden
        '--------------------------------
        Using sr As StreamReader = New StreamReader(Directory + "Frequenz.dat")

            Do
                Line = sr.ReadLine()
                F(I, 0) = Line
                Line = sr.ReadLine()
                F(I, 1) = Line
                Line = sr.ReadLine()
                F(I, 2) = Line

                I = I + 1
            Loop Until Line = 0

            TBE = I - 2 '242, letzter gültiger Index

            sr.Close()

        End Using
    End Sub
    Public Sub loadFrequencyPositionTable()

        'Deklarationen
        '-------------
        Dim L As Integer 'Länge der Tabelle
        Dim I As Integer 'Laufvariable

        'ausgewähltes Band in Form bestimmen
        '-----------------------------------
        getBandIndex()

        'ausgewähltes Band laden
        '-----------------------
        FrequencyForm.DataGridView1.ColumnCount = 3
        L = R(BandIndex, 1) - R(BandIndex, 0)
        FrequencyForm.DataGridView1.RowCount = L + 1

        FrequencyForm.Show()

        For I = 0 To L
            FrequencyForm.DataGridView1.Rows(I).Cells(0).Value = Format(F(R(BandIndex, 0) + I, 0), "##.000")
            FrequencyForm.DataGridView1.Rows(I).Cells(1).Value = Format(F(R(BandIndex, 0) + I, 1), "##.00")
            FrequencyForm.DataGridView1.Rows(I).Cells(2).Value = Format(F(R(BandIndex, 0) + I, 2), "##.00")
        Next I

    End Sub
    Public Sub Main()

        If StopFlag = True Then Exit Sub 'fehlender TRX

        'Schleife
        '--------
        Do
            'Statusprüfung
            '-------------
            Application.DoEvents()
            getStatusTRX()
            determineBand()

            'Nachjustierung im Band erfolgt
            '------------------------------
            If PosBias(BandIndex, 1) <> 0 Or PosBias(BandIndex, 2) <> 0 Then
                Me.Button4.BackColor = Color.DimGray
            Else
                Me.Button4.BackColor = Color.Black
            End If

            'automatische Antennenumschaltung
            '--------------------------------
            If MODE = AUT And Antenne > 1 Then 'keine Magnetantenne
                setMode(MAN)
                setK2(EIN) 'Umschaltung auf andere Antenne, FD4
                Beep()
            End If

            'Positionsnachführung
            '--------------------
            If MODE = AUT And Frequency <> Fmem Then
                Fmem = Frequency
                calculateSetpoints()
                If SetpointC(1) <> PositionC(1) Then setPositionC(1, SetpointC(1)) 'nur nachführen,
                If SetpointC(2) <> PositionC(2) Then setPositionC(2, SetpointC(2)) 'wenn notwendig
            End If

            'Sendebetrieb
            '------------
            If TX = True Then
                getSWRantenna()
            Else
                Me.TextBox2.Text = "P = 0,0 W"
                Me.TextBox4.Text = "SWR = 1,00"
            End If

            'Taktanzeige
            '-----------
            Me.OvalShape12.FillColor = Color.Blue
            Application.DoEvents()
            Threading.Thread.Sleep(200)
            Me.OvalShape12.FillColor = Color.Black
            Application.DoEvents()
            Threading.Thread.Sleep(800)
        Loop

    End Sub
    Public Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Show()
        Init()
        Main()

    End Sub
    Public Sub reAdjustPosition()

        'Deklarationen
        '-------------
        Dim BW(2) As Single 'Bandbreite
        Dim T As String = ""
        Dim X As Integer
        Dim SWRmax As Single 'maximaler SWR-Wert für erfolgreiches Abstimmen 
        Dim OldSetpointC1 As Single
        Dim OldSetpointC2 As Single

        'Zuweisungen
        '-----------
        OldSetpointC1 = SetpointC(1) 'alte Werte merken
        OldSetpointC2 = SetpointC(2)

        PosBias(BandIndex, 1) = 0 'Korrekturwerte zurücksetzen
        PosBias(BandIndex, 2) = 0

        SWRmax = B(BandIndex, 5)
        BW(1) = B(BandIndex, 6) / 2 '0.3 Bandbreite beim Wobbeln/2
        BW(2) = B(BandIndex, 7) / 2 '1.5
        SMode = 1 'TRX

        Me.Button4.ForeColor = Color.Red
        Me.TextBox6.Text = "Tuning"

        setMode(MAN) 'Bedienteil in MAN

        determineBand() 'zugeordnetes Band finden

        calculateSetpoints()
        RPC(1) = SetpointC(1) / StepsC(1) * 100 'bisherige Resonanzpunkte übernehmen
        RPC(2) = SetpointC(2) / StepsC(2) * 100

        setPositionC(1, Math.Round(RPC(1) * StepsC(1) / 100)) 'auf bisherige Position fahren
        setPositionC(2, Math.Round(RPC(2) * StepsC(2) / 100))

        Me.SerialPort2.Write(StartButton & "1;") 'TRX On
        adjustTuningPower() 'notwendige Abstimmleistung einstellen

        'Log vorbereiten
        '---------------
        LogForm.Show()
        LogForm.Close()
        LogForm.Show()

        LogForm.TextBox1.Text = T

        My.Application.DoEvents()
        Threading.Thread.Sleep(50)

        Dim u As Graphics = LogForm.CreateGraphics()
        Dim myPen As New Pen(Color.Lime, 1)

        'waagerechte Referenzlinie zeichnen
        '----------------------------------
        x1 = x0
        x2 = x0 + 250 'horizontale Position
        y1 = y0 + (-SWRmax * 400) + 600 'vertikale Position 
        y2 = y1
        u.DrawLine(myPen, x1, y1, x2, y2)

        'Kennzeichnung Mitte
        '-------------------
        x1 = x0 + (x2 - x1) / 2
        x2 = x1
        y1 = y1 + 10
        y2 = y1 - 20
        u.DrawLine(myPen, x1, y1, x2, y2)

        'Resonanz-/Impedanzpositionen suchen
        '-----------------------------------
        X = 1 'Index für Beginn mit C1 setzen  

        'C(x) wobbeln
        '------------
        Do
            x1 = x0
            x2 = x1

            wobbelC(X, RPC(X), BW(X)) 'aktuellen Resonanzpunkt suchen

            If AFlag = True Then 'manueller Abbruch
                Me.SerialPort2.Write(TunePowerSetting & Format(TuningPowerSaved, "000") & ";") 'Tuningleistung auf 4 Watt einstellen
                Me.TextBox6.Text = "Abbruch"
                Me.Button4.ForeColor = Color.White
                LogForm.Close()
                FrequencyForm.Close()
                AFlag = False
                Exit Sub
            End If

            setPositionC(X, Math.Round((RPC(X) - BW(X)) * StepsC(X) / 100)) 'zurück fahren, Spiel-Kompensation
            setPositionC(X, Math.Round(RPC(X) * StepsC(X) / 100)) 'aktuellen Resonanzpunkt von unten anfahren

            T = T & Format(Frequency, "###.000") & "  C" &
                Microsoft.VisualBasic.Right(X, 1) & "  SWR " & _
                Format(SWRrp, "0.000") & "  RP " & _
                Format(RPC(X), "00.00") & " % " & _
                vbCr & vbLf 'Text für Tune Log aufbereiten

            T = Microsoft.VisualBasic.Right(T, (28 * 36)) 'Begrenzung der Textlänge
            LogForm.TextBox1.Text = T
            '........................................
            If SWRrp <= SWRmax And X = 1 Then Exit Do 'genau genug, Ausstieg bei C(1) aus der Schleife
            '.........................................
            If X = 1 Then X = 2 Else X = 1 'den jeweils anderen Kondensator auswählen
        Loop

        'Ergebnisse speichern
        '--------------------
        PosBias(BandIndex, 1) = RPC(1) * StepsC(1) / 100 - OldSetpointC1
        PosBias(BandIndex, 2) = RPC(2) * StepsC(2) / 100 - OldSetpointC2

        'TX ausschalten
        '--------------
        Me.SerialPort2.Write(TuneStatus & "0;") 'Tuning aus
        Threading.Thread.Sleep(100)
        Me.SerialPort2.Write(TunePowerSetting & Format(TuningPowerSaved, "000") & ";") 'Tuningleistung auf 4 W einstellen

        setMode(AUT) 'Bedienteil wieder in AUT setzen

        'Form bereinigen
        '---------------
        Me.TextBox2.Text = "P = 0,0 W"
        Me.TextBox4.Text = "SWR = 1,00"
        Me.TextBox6.Text = "Tuning OK"
        Me.Button4.ForeColor = Color.White
        LogForm.Close()

    End Sub
    Public Sub saveBandParameter()

        'Deklarationen
        '-------------
        Dim Line As String
        Dim I As Integer
        Dim J As Integer

        'Zuweisungen
        '-----------
        Line = ""

        'Daten von Tabelle ins Array laden
        '---------------------------------
        For I = 0 To 9
            For J = 0 To 8
                B(I, J) = BandForm.DataGridView2.Rows(I).Cells(J).Value
            Next J
        Next I

        'Daten vom Array auf Platte speichern
        '------------------------------------
        Using sw As StreamWriter = New StreamWriter(Directory + "Band.dat")

            For I = 0 To 9 'Zeilen
                For J = 0 To 8 'Spalten
                    sw.WriteLine(B(I, J))
                Next J
            Next I

            sw.Close()

        End Using

    End Sub
    Public Sub saveFrequencyPositionParameter()

        'Deklarationen
        '-------------
        Dim Line As String
        Dim I As Integer
        Dim J As Integer
        Dim L As Integer

        'Zuweisungen
        '-----------
        Line = ""

        'Daten von Tabelle ins Array laden, nur das ausgewählte Band aktualisieren!
        '--------------------------------------------------------------------------
        L = R(BandIndex, 1) - R(BandIndex, 0) '= 35 bei Bandindex 4
        J = R(BandIndex, 0) '= 83

        For I = 0 To L '35
            'Frequenzspalte bleibt unverändert!
            F(I + J, 1) = CDbl(FrequencyForm.DataGridView1.Rows(I).Cells(1).Value)
            F(I + J, 2) = CDbl(FrequencyForm.DataGridView1.Rows(I).Cells(2).Value)
        Next I

        'Daten vom gesamten Array auf Platte speichern
        '---------------------------------------------
        Using sw As StreamWriter = New StreamWriter(Directory + "Frequenz.dat")

            For I = 0 To TBE + 1 'letzte Zeile Nullen
                For J = 0 To 2
                    sw.WriteLine(F(I, J))
                Next J
            Next I

            sw.Close()

        End Using

    End Sub
    Public Sub setHomePositionC(ByVal X As Integer)

        'Deklarationen
        '-------------
        Dim Buffer As String
        Dim I As Integer
        Dim DeviationC(2) As Integer

        'Zuweisungen
        '-----------
        BusyFlag = True
        Buffer = ""

        If X = 1 Then
            Me.OvalShape1.FillColor = Color.Red 'rote LED ein
            Me.TextBox4.Text = "Nullabgleich"
        Else
            Me.OvalShape1.FillColor = Color.Yellow 'gelbe LED ein
            Me.TextBox6.Text = "Nullabgleich"
        End If

        Me.Button6.ForeColor = Color.Red

        'Kommando senden
        '---------------
        Me.SerialPort1.DiscardInBuffer()
        If X = 1 Then
            Me.SerialPort1.ReadTimeout = 28000
            Me.SerialPort1.Write("G1" & vbCr)
        Else
            Me.SerialPort1.ReadTimeout = 7000
            Me.SerialPort1.Write("G2" & vbCr)
        End If

        Threading.Thread.Sleep(10)

        'Antwort empfangen
        '-----------------
        Me.SerialPort1.DiscardInBuffer()
        Try
            Do
                My.Application.DoEvents()
                I = Me.SerialPort1.ReadChar
                Buffer = Buffer + Chr(I)
            Loop Until I = 13
        Catch ex As TimeoutException
            Buffer = "Timeout" : Beep()
        End Try

        'Abweichung anzeigen
        '-------------------
        If Buffer = "Timeout" Then
            If X = 1 Then Me.TextBox4.Text = Buffer
            If X = 2 Then Me.TextBox6.Text = Buffer
        Else
            If Microsoft.VisualBasic.Left(Buffer, 1) <> "G" Then Buffer = Mid(Buffer, 2) 'Fehlerbehebung unbekannter Ursache
            If X = 1 Then
                DeviationC(1) = CInt(Mid(Buffer, 3, Len(Buffer) - 3))
                My.Application.DoEvents()
                Me.TextBox4.Text = "dC1 = " & DeviationC(1)
            Else
                DeviationC(2) = CInt(Mid(Buffer, 3, Len(Buffer) - 3))
                Me.TextBox6.Text = "dC2 = " & DeviationC(2)
            End If

        End If

        'Ergebnis der globalen Variablen zuweisen
        '----------------------------------------
        PositionC(1) = 0
        PositionC(2) = 0
        SetpointC(1) = 0
        SetpointC(2) = 0
        Fmem = 0

        My.Application.DoEvents()

        If X = 1 Then
            Me.TextBox3.Text = "C1 = " & Format(0, "##0.00") & " %"     'Position anzeigen
            Me.TrackBar1.Value = 0                                    'Position anzeigen
        Else
            Me.TextBox5.Text = "C2 = " & Format(0, "##0.00") & " %"     'Position anzeigen
            Me.TrackBar2.Value = 0  'Position anzeigen
        End If

        Threading.Thread.Sleep(2000)
        Me.OvalShape1.FillColor = Color.Lime                'grüne LED ein
        Me.Button6.ForeColor = Color.White
        BusyFlag = False

    End Sub
    Public Sub setK1(ByVal X As Boolean)

        'Deklarationen
        '-------------
        Dim Buffer As String
        Dim I As Integer

        'Zuweisungen
        '-----------
        Me.CheckBox1.Checked = X
        Buffer = ""

        'Kommando senden
        '---------------
        Me.SerialPort1.ReadTimeout = 500

        If X = True Then
            Me.SerialPort1.Write("K11" + vbCr)
            Me.CheckBox1.Text = "1 A"
        Else
            Me.SerialPort1.Write("K10" + vbCr)
            Me.CheckBox1.Text = "1  "
        End If

        'Antwort empfangen
        '-----------------
        Try
            Do
                I = Me.SerialPort1.ReadChar
                Buffer = Buffer + Chr(I)
            Loop Until I = 13
        Catch ex As TimeoutException
            Buffer = "Timeout" : Beep()
        Finally
            '
        End Try

    End Sub
    Public Sub setK2(ByVal X As Boolean)

        'Deklarationen
        '-------------
        Dim Buffer As String
        Dim I As Integer

        'Zuweisungen
        '-----------
        Me.CheckBox2.Checked = X
        Buffer = ""

        'Kommando senden
        '---------------
        Me.SerialPort1.ReadTimeout = 500

        If X = True Then
            Me.SerialPort1.Write("K21" + vbCr)
            Me.CheckBox2.Text = "2 W"
        Else
            Me.SerialPort1.Write("K20" + vbCr)
            Me.CheckBox2.Text = "2 M"
        End If

        'Antwort empfangen
        '-----------------
        Try
            Do
                I = Me.SerialPort1.ReadChar
                Buffer = Buffer + Chr(I)
            Loop Until I = 13
        Catch ex As TimeoutException
            Buffer = "Timeout" : Beep()
        Finally
            '
        End Try

    End Sub
    Public Sub setLED(ByVal x As Integer)

        If x = 0 Then Me.OvalShape2.FillColor = Color.Yellow Else Me.OvalShape2.FillColor = Color.Olive
        If x = 1 Then Me.OvalShape3.FillColor = Color.Yellow Else Me.OvalShape3.FillColor = Color.Olive
        If x = 2 Then Me.OvalShape4.FillColor = Color.Yellow Else Me.OvalShape4.FillColor = Color.Olive
        If x = 3 Then Me.OvalShape5.FillColor = Color.Yellow Else Me.OvalShape5.FillColor = Color.Olive
        If x = 4 Then Me.OvalShape6.FillColor = Color.Yellow Else Me.OvalShape6.FillColor = Color.Olive
        If x = 5 Then Me.OvalShape7.FillColor = Color.Yellow Else Me.OvalShape7.FillColor = Color.Olive
        If x = 6 Then Me.OvalShape8.FillColor = Color.Yellow Else Me.OvalShape8.FillColor = Color.Olive
        If x = 7 Then Me.OvalShape9.FillColor = Color.Yellow Else Me.OvalShape9.FillColor = Color.Olive
        If x = 8 Then Me.OvalShape10.FillColor = Color.Yellow Else Me.OvalShape10.FillColor = Color.Olive
        If x = 9 Then Me.OvalShape11.FillColor = Color.Yellow Else Me.OvalShape11.FillColor = Color.Olive

    End Sub
    Public Sub setMode(ByVal x As Boolean)

        'Zuweisungen
        '-----------
        MODE = x

        If x = AUT Then
            Me.RadioButton1.Checked = True
            Me.RadioButton2.Checked = False
        Else
            Me.RadioButton1.Checked = False
            Me.RadioButton2.Checked = True
        End If

    End Sub
    Public Sub setPositionC(ByVal X As Integer, ByVal Y As Integer)

        'Deklarationen
        '-------------
        Dim Buffer As String
        Dim I As Integer
        Dim Z As Integer

        'Zuweisungen
        '-----------

        SetpointC(X) = Y
        '**********************************************************************
        'Korrektur durch Nachjustierung wird nur an dieser Stelle durchgeführt!
        Z = Y + PosBias(BandIndex, X)
        'Debug.Print(PosBias(BandIndex, 1) & " " & PosBias(BandIndex, 2))
        '**********************************************************************
        BusyFlag = True
        Buffer = ""

        If X = 1 Then Me.OvalShape1.FillColor = Color.Red 'rote LED ein
        If X = 2 Then Me.OvalShape1.FillColor = Color.Yellow 'gelbe LED ein

        'Kommando senden
        '---------------
        Me.SerialPort1.ReadTimeout = 14000

        If X = 1 Then Me.SerialPort1.Write("P1" & Z & vbCr)
        If X = 2 Then Me.SerialPort1.Write("P2" & Z & vbCr)
        Threading.Thread.Sleep(10)

        'Antwort empfangen
        '-----------------
        Try
            Do
                My.Application.DoEvents()
                I = Me.SerialPort1.ReadChar
                Buffer = Buffer + Chr(I)
            Loop Until I = 13
        Catch ex As TimeoutException
            Beep()
        Finally
            '
        End Try

        'Ergebnis der globalen Variablen zuweisen
        '----------------------------------------
        PositionC(X) = SetpointC(X) 'Mid(Buffer, 3, Len(Buffer) - 3)
        'wegen möglicher Timeouts wird die Rückmeldung derzeit nicht verwertet!

        If X = 1 Then
            Me.TextBox3.Text = "C1 = " & Format(PositionC(X) / StepsC(X) * 100, "##0.00") & " %" 'Position anzeigen
            Me.TrackBar1.Value = PositionC(X)                   'Position nachführen
        Else
            Me.TextBox5.Text = "C2 = " & Format(PositionC(X) / StepsC(X) * 100, "##0.00") & " %" 'Position anzeigen
            Me.TrackBar2.Value = PositionC(X)                   'Position nachführen
        End If

        Me.OvalShape1.FillColor = Color.Lime                'grüne LED
        BusyFlag = False

    End Sub
    Public Sub setRadioButtons()

        If BandIndex = 0 Then FrequencyForm.RadioButton1.Checked = True
        If BandIndex = 1 Then FrequencyForm.RadioButton2.Checked = True
        If BandIndex = 2 Then FrequencyForm.RadioButton3.Checked = True
        If BandIndex = 3 Then FrequencyForm.RadioButton4.Checked = True
        If BandIndex = 4 Then FrequencyForm.RadioButton5.Checked = True
        If BandIndex = 5 Then FrequencyForm.RadioButton6.Checked = True
        If BandIndex = 6 Then FrequencyForm.RadioButton7.Checked = True
        If BandIndex = 7 Then FrequencyForm.RadioButton8.Checked = True
        If BandIndex = 8 Then FrequencyForm.RadioButton9.Checked = True
        If BandIndex = 9 Then FrequencyForm.RadioButton10.Checked = True

    End Sub
    Public Sub setVFOFrequency(ByVal F As Double)

        'Deklarationen
        '-------------
        Dim S As String
        Dim T As String

        'Format wandeln
        '--------------
        T = Format(F * 1000000, "00000000000")
        S = SetVfoAFrequency & T & ";"

        'Kommando senden
        '---------------
        Me.SerialPort2.Write(S)

        'Anzeige updaten
        '---------------
        S = Mid(S, 6, 8)
        Frequency = F
        Me.TextBox1.Text = Format(Val(Microsoft.VisualBasic.Left(S, 2)), "##") &
            "," & Mid(S, 3, 3) & "." & Microsoft.VisualBasic.Right(S, 3) & " MHz"

    End Sub
    Public Sub tuneLoop()

        'Deklarationen
        '-------------
        Dim I As Integer
        Dim StartFrequency As Double
        Dim StopFrequency As Double
        Dim Z As Integer 'Zähler zum Füllen der Tabelle
        Dim BW(2) As Single 'Bandbreite
        Dim T As String = ""
        Dim X As Integer
        Dim SWRmax As Single 'maximaler SWR-Wert für erfolgreiches Abstimmen 

        'Variablen für Dialogbox
        '-----------------------
        Dim msg As String
        Dim title As String
        Dim style As MsgBoxStyle
        Dim response As MsgBoxResult

        'Zuweisungen
        '-----------
        Z = 0 'Zeilenzähler Tabelle

        If SMode = 0 Then
            Me.SerialPort2.Write(StartButton & "0;") 'TRX Standby
            setMode(MAN)
            msg = "- PowerSDR geladen?" & vbCrLf ' Text Nachricht
            msg = msg & "- Frequenz innerhalb des gewünschten Bandes eingestellt?" & vbCrLf
            msg = msg & "- miniVNA an linke vordere USB-Buchse angeschlossen?" & vbCrLf
            msg = msg & "- miniVNA an Antenne angeschlossen?"
        Else
            Me.SerialPort2.Write(StartButton & "1;") 'TRX On
            setMode(MAN)
            msg = "- PowerSDR geladen?" & vbCrLf
            msg = msg & "- Frequenz innerhalb des gewünschten Bandes eingestellt?" & vbCrLf
            msg = msg & "- TRX an Antenne angeschlossen?"
        End If

        style = MsgBoxStyle.YesNo
        title = "Stepper Loop Tuner" 'Titel

        response = MsgBox(msg, style, title) 'Anzeige
        If response = MsgBoxResult.No Then Exit Sub

        If SMode = 0 Then
            Me.Button1.ForeColor = Color.Red
        Else
            Me.Button3.ForeColor = Color.Red
        End If

        Me.TextBox6.Text = "Tuning"
        calculateIndexArray()
        determineBand() 'zugeordnetes Band finden

        'Zuweisungen
        '------------
        PosBias(BandIndex, 1) = 0 'Korrekturwerte zurücksetzen
        PosBias(BandIndex, 2) = 0
        StartFrequency = B(BandIndex, 1) 'aus Bandtabelle
        StopFrequency = B(BandIndex, 2)
        Antenne = B(BandIndex, 4)
        SWRmax = B(BandIndex, 5)
        BW(1) = B(BandIndex, 6) / 2 '0.3 Bandbreite beim Wobbeln/2
        BW(2) = B(BandIndex, 7) / 2 '1.5

        setRadioButtons() 'für Aufruf Frequenztabelle vorbereiten

        'Startindex bestimmen
        '--------------------
        I = R(BandIndex, 0)

        loadFrequencyPositionTable()

        'mech. Nullpunkt abgleichen
        '--------------------------
        setHomePositionC(1)
        setHomePositionC(2)

        'Resonanz-/Impedanzpositionen suchen
        '-----------------------------------
        Do
            'Frequenz korrigieren, PowerSDR/FLEX-3000 reduziert sonst die Sendeleistung auf 0!
            '---------------------------------------------------------------------------------
            If I = R(BandIndex, 1) Then
                setVFOFrequency(Math.Round((F(I, 0)) - 0.004, 3)) 'Frequenz am Bandende um 4 kHz reduzieren
            Else
                setVFOFrequency(Math.Round((F(I, 0)), 3))
            End If

            If I = R(BandIndex, 0) Then
                setVFOFrequency(Math.Round((F(I, 0)) + 0.001, 3)) 'Frequenz am Bandanfang um 1 kHz erhöhen
            End If

            'positionieren
            '-------------
            If I = R(BandIndex, 0) Then
                RPC(1) = CSng(FrequencyForm.DataGridView1.Rows(0).Cells(1).Value) 'alte Resonanzpunkte aus 1. Zeile Tabelle holen!
                RPC(2) = CSng(FrequencyForm.DataGridView1.Rows(0).Cells(2).Value)
            End If

            setPositionC(1, Math.Round(RPC(1) * StepsC(1) / 100)) 'C(1) positionieren
            setPositionC(2, Math.Round(RPC(2) * StepsC(2) / 100)) 'C(2) positionieren

            If I = R(BandIndex, 0) And SMode = 1 Then adjustTuningPower() 'TRX-Betrieb

            LogForm.Show()
            LogForm.Close()
            LogForm.Show()

            LogForm.TextBox1.Text = T

            My.Application.DoEvents()
            Threading.Thread.Sleep(50)

            'Log vorbereiten
            '---------------
            Dim u As Graphics = LogForm.CreateGraphics()
            Dim myPen As New Pen(Color.Lime, 1)

            'waagerechte Referenzlinie zeichnen
            '----------------------------------
            x1 = x0
            x2 = x0 + 250 'horizontale Position
            y1 = y0 + (-SWRmax * 400) + 600 'vertikale Position 
            y2 = y1
            u.DrawLine(myPen, x1, y1, x2, y2)

            'Kennzeichnung Mitte
            '-------------------
            x1 = x0 + (x2 - x1) / 2
            x2 = x1
            y1 = y1 + 10
            y2 = y1 - 20
            u.DrawLine(myPen, x1, y1, x2, y2)

            X = 1 'Index für Beginn mit C1 setzen  

            'C(x) wobbeln
            '------------
            Do
                x1 = x0
                x2 = x1

                wobbelC(X, RPC(X), BW(X)) 'aktuellen Resonanzpunkt suchen

                If AFlag = True Then 'manueller Abbruch
                    Me.SerialPort2.Write(TunePowerSetting & Format(TuningPowerSaved, "000") & ";") 'Tuningleistung auf 4 Watt einstellen
                    Me.TextBox6.Text = "Abbruch"
                    Me.Button1.ForeColor = Color.White
                    Me.Button3.ForeColor = Color.White
                    LogForm.Close()
                    FrequencyForm.Close()
                    AFlag = False
                    Exit Sub
                End If

                setPositionC(X, Math.Round((RPC(X) - BW(X)) * StepsC(X) / 100)) 'zurück fahren, Spiel-Kompensation
                setPositionC(X, Math.Round(RPC(X) * StepsC(X) / 100)) 'aktuellen Resonanzpunkt von unten anfahren

                T = T & Format(F(I, 0), "###.000") & "  C" &
                    Microsoft.VisualBasic.Right(X, 1) & "  SWR " & _
                    Format(SWRrp, "0.000") & "  RP " & _
                    Format(RPC(X), "00.00") & " % " & _
                    vbCr & vbLf 'Text für Tune Log aufbereiten

                T = Microsoft.VisualBasic.Right(T, (28 * 36)) 'Begrenzung der Textlänge
                LogForm.TextBox1.Text = T
                '........................................
                If SWRrp <= SWRmax And X = 1 Then Exit Do 'genau genug, Ausstieg bei C(1) aus der Schleife
                '.........................................
                If X = 1 Then X = 2 Else X = 1 'den jeweils anderen Kondensator auswählen

            Loop

            'Ergebnisse wegschreiben, zunächst in Tabelle!
            '---------------------------------------------
            FrequencyForm.DataGridView1.Rows(Z).Cells(1).Value = Format(RPC(1), "0.00")  'Pos. C1
            FrequencyForm.DataGridView1.Rows(Z).Cells(2).Value = Format(RPC(2), "0.00")  'Pos. C2

            I = I + 1
            Z = Z + 1
            If I > R(BandIndex, 1) Then Exit Do 'Bandende erreicht
            If I > TBE Then Beep() : Exit Sub 'nichts gefunden
        Loop

        'TX ausschalten
        '--------------
        Me.SerialPort2.Write(TuneStatus & "0;") 'Tuning aus
        Me.SerialPort2.Write(TunePowerSetting & Format(TuningPowerSaved, "000") & ";") 'alter Zustand

        'Form bereinigen
        '---------------
        Me.TextBox2.Text = "P = 0,0 W"
        Me.TextBox4.Text = "SWR = 1,00"
        Me.TextBox6.Text = "Tuning OK"
        Me.Button1.ForeColor = Color.White
        Me.Button3.ForeColor = Color.White

        'Frequenz- und Positionsdaten sichern
        '------------------------------------
        msg = "Die Abgleichroutine für das Band ist beendet." & vbCrLf ' Define message.
        msg = msg & "Sollen die Ergebnisse abgespeichert werden?"
        style = MsgBoxStyle.YesNo
        title = "Stepper Loop Tuner"

        response = MsgBox(msg, style, title)
        If response = MsgBoxResult.Yes Then
            saveFrequencyPositionParameter()
        End If

        LogForm.Close()
        FrequencyForm.Close()
        setMode(AUT)

    End Sub
    Public Sub wobbelC(ByVal X, ByVal I, ByVal J)

        'X = C1 oder C2
        'I = Resonanzpunkt
        'J = Wobbelbandbreite/2

        'Deklarationen
        '-------------
        Dim S As Single 'Schleppzeiger SWR
        Dim A As Integer 'Anfang des Bereiches
        Dim E As Integer 'dto. Ende
        Dim StepSize As Integer 'Schrittweite
        Dim N As Integer 'Laufvariable Position
        Dim RP As Integer 'aktueller Resonanzpunkt

        'Zuweisungen
        '-----------
        A = Int((I - J) * StepsC(X) / 100) 'Anfang, Umrechnung in Schrittposition
        E = Int((I + J) * StepsC(X) / 100) 'Ende, I entspricht Mittelpunkt, J entspricht 1/2 Bandbreite
        S = 100 'Schleppzeiger SWR hochsetzen
        StepSize = 1
        N = A

        'VNA- oder TRX-Betrieb
        '---------------------
        If SMode = 0 Then
            SWRlimit = 0.02 'miniVNA
        Else
            SWRlimit = 0.1 'TRX, größerer Unterschied notwendig
            Me.SerialPort2.Write(TuneStatus & "1;") 'Tuning ein
        End If

        'SWR mit steigender Position messen und auswerten
        '------------------------------------------------
        Do
            My.Application.DoEvents()
            If AFlag = True Then 'manueller Abbruch
                Me.SerialPort2.Write(TuneStatus & "0;") 'Tuning aus
                Me.SerialPort2.Write(TunePowerSetting & Format(TuningPowerSaved, "000") & ";") 'Tuningleistung auf 4 Watt einstellen
                Exit Sub
            End If

            setPositionC(X, N) 'beginnend mit tiefster Position

            If SMode = 0 Then 'Verwendung des miniVNA 
                If X = 1 Then 'C(1)
                    getSWRsingleShot() 'C(1)
                Else
                    getSWRmultiShot() 'C(2)
                End If
            Else 'TRX-Betrieb
                Me.SerialPort2.Write(TunePowerSetting & Format(TuningPower, "000") & ";") 'Tuningleistung aktivieren
                Me.TextBox2.BackColor = Color.Red
                My.Application.DoEvents()
                Threading.Thread.Sleep(200)

                getSWRantenna()

                LogForm.TextBox2.Text = "SWR = " & Format(SWR, "0.000")
                LogForm.TextBox3.Text = Format(Frequency, "##.000") & " MHz"

                Me.SerialPort2.Write(TunePowerSetting & "000;") 'Tuningleistung 0
                Me.TextBox2.BackColor = Color.Black
            End If

            If X = 1 Then drawSWR((N - A) * 250 / (B(BandIndex, 6) * StepsC(1) / 100), Color.Red, 2) 'bei tiefster Position = 0
            If X = 2 Then drawSWR((N - A) * 250 / (B(BandIndex, 7) * StepsC(2) / 100), Color.Yellow, 2)

            StepSize = Int(SWR) 'ggf. Erhöhung der Schrittweite
            N = N + StepSize

            If SWR < S Then 'Daten aktualisieren
                S = SWR
                SWRrp = SWR
                RP = N
                LogForm.TextBox4.Text = "SWRmin = " & Format(S, "0.000")
            End If

            If SWR - S >= SWRlimit Then Exit Do 'Schleife abbrechen, wenn SWR wieder nennenswert angestiegen ist

        Loop While N <= E

        'Umrechnung in %
        '---------------
        RPC(X) = Math.Round(RP / (StepsC(X) / 100), 2) 'Ergebnis zuweisen
        If X = 1 Then Me.TextBox4.Text = "RP " & Format(RPC(X), "0.00") & " %"
        If X = 2 Then Me.TextBox6.Text = "RP " & Format(RPC(X), "0.00") & " %"

    End Sub

    Public Function SWRmultiShot(ByVal Frequency As Double)

        'Deklarationen
        '-------------
        Dim InitFreqBits As Long
        Dim RLbits As Long
        Dim RL As Double
        Dim ClockFreq As Double
        Dim RhoMag As Double, Zo As Double
        Dim Hz2Bits As Double
        Dim RLBits2dB As Double
        Dim I As Integer 'Laufvariable Byteabfrage
        Dim J As Byte 'serielle Daten, Ergebnisse
        Dim K As Integer 'Laufvariable Messungen

        Dim Fdiff As Double 'Differenzfrequenz Nenn-/Startfrequenz
        Dim Fincr As Double 'Frequenzinkrement
        Dim Fstart As Double 'Startfrequenz
        Dim Samples As Integer = 20 'Zahl der Messungen

        'Zuweisungen
        '-----------
        ClockFreq = 400000000 '[ScanClockFreq]
        Hz2Bits = 10.737823 'minivna 

        'ursprüngliche Einstellung des VNA:  10.737523
        'neue Einstellung nach Justierung:   10.737823
        'Wert der urspr. Programmberechnung: 10.7374182375 = (2 ^ 32 - 1) / ClockFreq 

        RLBits2dB = 60 / (2 ^ 10 - 1) '=~0.06 dB per bit

        Fdiff = Frequency / 1000 ' * 0.03 * 0.12 '0.1008 MHz bei 28 MHz und 3% WBB
        Fincr = Fdiff / 10
        Fstart = Frequency - Fdiff
        InitFreqBits = CLng(Fstart * 1000000 * Hz2Bits)
        Zo = 50
        SWRmultiShot = 100 'Schleppzeiger hochsetzen

        'Kommandos senden
        '----------------
        Me.SerialPort3.Open()
        Me.SerialPort3.ReadTimeout = 500

        Me.SerialPort3.Write(CStr(0) & vbCr)  'Rx mode
        Threading.Thread.Sleep(10)
        Me.SerialPort3.Write(CStr(InitFreqBits) & vbCr) 'initial frequency (same for both steps)
        Threading.Thread.Sleep(10)
        Me.SerialPort3.Write(CStr(Samples * 2) & vbCr)  'number of samples
        Threading.Thread.Sleep(10)
        InitFreqBits = CLng(Fincr * 1000000 * Hz2Bits)
        Me.SerialPort3.Write(CStr(InitFreqBits) & vbCr)  'step increment

        'Antwort empfangen
        '-----------------
        Me.SerialPort3.DiscardInBuffer() 'clear input buffer
        Try

            'Meßdaten auswerten
            '------------------
            For I = 0 To Samples
                My.Application.DoEvents()

                J = Me.SerialPort3.ReadByte 'Byte verwerfen
                J = Me.SerialPort3.ReadByte 'Byte verwerfen
                RLbits = Me.SerialPort3.ReadByte 'low Byte
                J = Me.SerialPort3.ReadByte 'high Byte
                RLbits = RLbits + (J * 256)

                'SWR berechnen
                '-------------
                RL = RLbits * RLBits2dB - 21.1 'korrigiert, alt 20.16
                RhoMag = 10 ^ (-RL / 20)
                SWR = (1 + RhoMag) / (1 - RhoMag)

                If SWR < SWRmultiShot Then
                    SWRmultiShot = SWR
                    FreqSWRmultiShot = Fstart + K * Fincr
                End If
                K = K + 1
            Next I

        Catch ex As TimeoutException
        Finally
            Me.SerialPort3.Close()
        End Try

        Me.SerialPort3.Close()

        Return SWRmultiShot

    End Function
    Public Function SWRsingleShot(ByVal Frequency As Double)

        'Deklarationen
        '-------------
        Dim InitFreqBits As Long
        Dim RLbits As Long
        Dim RL As Double
        Dim ClockFreq As Double
        Dim RhoMag As Double, Zo As Double
        Dim Hz2Bits As Double
        Dim RLBits2dB As Double
        Dim I As Integer
        Dim J As Byte

        'Zuweisungen
        '-----------
        ClockFreq = 400000000 '[ScanClockFreq]
        Hz2Bits = 10.737823 'minivna

        'ursprüngliche Einstellung des VNA:  10.737523
        'neue Einstellung nach Justierung:   10.737823
        'Wert der urspr. Programmberechnung: 10.7374182375 = (2 ^ 32 - 1) / ClockFreq 

        RLBits2dB = 60 / (2 ^ 10 - 1) '=~0.06 dB per bit
        InitFreqBits = CLng(Frequency * 1000000 * Hz2Bits)
        Zo = 50

        'Kommandos senden
        '----------------
        Me.SerialPort3.Open()
        Me.SerialPort3.ReadTimeout = 500

        Me.SerialPort3.Write(CStr(0) & vbCr)  'Rx mode
        Threading.Thread.Sleep(10)
        Me.SerialPort3.Write(CStr(InitFreqBits) & vbCr) 'initial frequency (same for both steps)
        Threading.Thread.Sleep(10)
        Me.SerialPort3.Write("2" & vbCr)  'number of steps, extra step for garbage #1
        Threading.Thread.Sleep(10)
        Me.SerialPort3.Write("0" & vbCr)  '0 step increment

        'Antwort empfangen
        '-----------------
        Me.SerialPort3.DiscardInBuffer() 'clear input buffer
        Try
            For I = 0 To 5
                My.Application.DoEvents()
                J = Me.SerialPort3.ReadByte   'verwerfen
            Next I

            J = Me.SerialPort3.ReadByte 'Byte 6
            RLbits = J

            J = Me.SerialPort3.ReadByte 'Byte 7
            RLbits = RLbits + (J * 256)

        Catch ex As TimeoutException
            Me.TextBox6.Text = "Timeout" : Beep()
        Finally
            Me.SerialPort3.Close()
        End Try

        Me.SerialPort3.Close()

        'SWR berechnen
        '-------------
        RL = RLbits * RLBits2dB - 21.1 '20.16

        RhoMag = 10 ^ (-RL / 20)
        SWR = (1 + RhoMag) / (1 - RhoMag)

        If SWR < 0 Then SWR = SWR * (-1) 'negative Ergebnisse beobachtet

        Return SWR

    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        SMode = 0 'miniVNA
        tuneLoop()

    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        StartFlag = True

    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        SMode = 1 'TRX
        tuneLoop()

    End Sub
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        If BusyFlag = False Then

            reAdjustPosition()

            ''Deklarationen
            ''-------------
            'Dim msg As String 'Variablen für Dialogbox
            'Dim title As String
            'Dim style As MsgBoxStyle
            'Dim response As MsgBoxResult

            'msg = "Nachjustierung noch nicht verfügbar!" & vbCrLf
            'style = MsgBoxStyle.OkOnly
            'title = "Stepper Loop Tuner"
            'response = MsgBox(msg, style, title)
        Else
            Beep()
        End If

    End Sub
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        AFlag = True

    End Sub
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click

        If MODE = MAN And BusyFlag = False Then
            setHomePositionC(1)
            setHomePositionC(2)
        Else
            Beep()
        End If

    End Sub
    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click

        setRadioButtons()
        loadBandParameter()
        loadFrequencyPositionParameter()
        loadFrequencyPositionTable()
        BandForm.Show()

    End Sub
    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click

        SerialPort1.Close()
        SerialPort2.Close()
        SerialPort3.Close()
        End

    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged

        If CheckBox1.Checked = True Then
            setK1(EIN)
        Else
            setK1(AUS)
        End If

    End Sub
    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged

        If CheckBox2.Checked = True Then
            setK2(EIN)
        Else
            setK2(AUS)
        End If

    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged

        If Me.RadioButton1.Checked = True Then
            MODE = AUT
            Me.TrackBar1.Enabled = False
            Me.TrackBar2.Enabled = False
        End If

    End Sub
    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged

        If Me.RadioButton2.Checked = True Then
            MODE = MAN
            Me.TrackBar1.Enabled = True
            Me.TrackBar2.Enabled = True
        End If

    End Sub

    Private Sub TrackBar2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar2.ValueChanged

        If MODE = MAN And BusyFlag = False Then
            Dim X As Integer
            X = Me.TrackBar2.Value 'Me.HScrollBar2.Value
            If X <> PositionC(2) Then
                SetpointC(2) = X 'Synchronisierung für AUT 
                setPositionC(2, X)
                Fmem = 0
            End If
        End If

    End Sub
    Private Sub TrackBar1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.ValueChanged

        If MODE = MAN And BusyFlag = False Then
            Dim X As Integer
            X = Me.TrackBar1.Value
            If X <> PositionC(1) Then
                SetpointC(1) = X 'Synchronisierung für AUT  
                setPositionC(1, X)
                Fmem = 0
            End If
        End If
    End Sub

End Class
